/*-----------------------------------------------------------------------------
CLOCK RATE REQUIRED : 1M 
THE SEG START FROM LEFT HAND, 1~8
THERE ARE 3MODES FOR 7289 TO DECODE
     MODE0:0~9,-,E,H,L,P,NULL
     MODE1:0~F
     MODE2:UNDECODE
 
-----------------------------------------------------------------------------*/

#ifndef __ZLG7289_H__
#define __ZLG7289_H__

/*----------------------------  I N C L U D E S  -----------------------------*/
#include "msp430g2211.h"

/*------------------------------  M A C R O S  -------------------------------*/
/* ZLG7289ú궨 */
#define ZLG7289_CS                     BIT2               // Ƭѡźţ͵ƽЧ(P1.2)
#define ZLG7289_CLK                    BIT3               // ʱźţЧ(p1.3)
#define ZLG7289_DATA                   BIT4               // źţ˫(P1.4)
#define ZLG7289_KEY                    BIT5               // ʱKEYΪ͵ƽ(P1.5)

#define ZLG7289_CS_OUT                 P1DIR |= ZLG7289_CS
#define ZLG7289_CLK_OUT                P1DIR |= ZLG7289_CLK
#define ZLG7289_DATA_OUT               P1DIR |= ZLG7289_DATA
#define ZLG7289_DATA_IN                P1DIR &=~ZLG7289_DATA;\
                                       P1REN |= ZLG7289_DATA
#define ZLG7289_KEY_IN                 P1DIR &=~ZLG7289_KEY;\
                                       P1REN |= ZLG7289_KEY

#define ceshi                          P1OUT ^= BIT0        

#define ZLG7289_DATA_PORT              (P1IN & ZLG7289_DATA)
#define ZLG7289_KEY_PORT               (P1IN & ZLG7289_KEY)


#define CS_HIGH                        P1OUT |= ZLG7289_CS
#define CS_LOW                         P1OUT &=~ ZLG7289_CS
#define CLK_HIGH                       P1OUT |= ZLG7289_CLK
#define CLK_LOW                        P1OUT &=~ ZLG7289_CLK
#define DATA_HIGH                      P1OUT |= ZLG7289_DATA
#define DATA_LOW                       P1OUT &=~ ZLG7289_DATA

#define CMD_RESET                      0xA4		// λ()ָ
#define CMD_TEST                       0xBF		// ָ
#define RTL_CYCLE                      0xA3		// ѭָ
#define RTR_CYCLE                      0xA2		// ѭָ
#define RTL_UNCYL                      0xA1		// ָ
#define RTR_UNCYL                      0xA0		// ָ

#define DECODE0                        0x80		// Ұʽ0
#define DECODE1                        0xC8		// Ұʽ1
#define UNDECODE                       0x90		// ݵ(Сʾ)
#define BLINKCTL                       0x88		// ˸
#define ACTCTL                         0x98		// 

#define SEGON                          0xE0		// εָ	
#define SEGOFF                         0xC0		// ιرָ
#define CMD_READ                       0x15		// ȡָ

/* ZLG7289ʾ궨 */
#define DP_DISPLAY                     0x80             // ʾС
#define DP_DONT_DISPLAY                0x00             // ʾС
#define MINUS_DISPLAY                  0x0A             // ʾ

#define SEG_A_DISPLAY                  0x40             // Seg A
#define SEG_B_DISPLAY                  0x20             // Seg B
#define SEG_C_DISPLAY                  0x10             // Seg C
#define SEG_D_DISPLAY                  0x08             // Seg D
#define SEG_E_DISPLAY                  0x04             // Seg E
#define SEG_F_DISPLAY                  0x02             // Seg F
#define SEG_G_DISPLAY                  0x01             // Seg G
#define SEG_DP_DISPLAY                 0x80             // Seg DP
#define NOTHING_DISPLAY                0x0F             // ʾ

#define SEG_A                          6                // ʱAΪĴ6λ
#define SEG_B                          5                // ʱBΪĴ5λ
#define SEG_C                          4                // ʱCΪĴ4λ
#define SEG_D                          3                // ʱDΪĴ3λ
#define SEG_E                          2                // ʱEΪĴ2λ
#define SEG_F                          1                // ʱFΪĴ1λ
#define SEG_G                          0                // ʱGΪĴ0λ

/*-------------------------  D E C L A R A T I O N  --------------------------*/

/* Internal Variable */

/* External Variable */

/* Internal Function */
void  Delay_ms(int i);
void Delay_us(int i);
void SPIWriteAByte(unsigned char byte);
void Write7289Cmd(unsigned char cmd);
void Write7289CmdAndData(unsigned char cmd, unsigned char data);
unsigned char SPIReadAByte(void);
unsigned char GetKey7289(void);


/* External Function */
extern void ZLG7289Init(void);
extern void DisplayClearAll(void);
extern void SegDisplay_0(unsigned char segbit, unsigned char segnum);
extern void SegDisplay_1(unsigned char segbit, unsigned char segnum);
extern void SegDisplay_2(unsigned char segbit, unsigned char segnum);
extern void BitDisplayNothing(unsigned char dig_start, unsigned char dig_end);
extern char DisplayData(unsigned char dig_start, unsigned char dig_end, float num);

#endif


void  Delay_ms(int i)
{
  int t;
  while(i--)
  {
    t=1000;
    while(t--)
      ;
  }
}

void Delay_us(int i)
{
  while(i--);
}

void ZLG7289Init(void)
{
    // ȴϵͳȶ  
    Delay_ms(5);
  
    // ZLG7289ŷ
    ZLG7289_CS_OUT;       // CS: Output
    ZLG7289_CLK_OUT;      // CLK: Output
    ZLG7289_DATA_OUT;   // DATA: Output
    ZLG7289_KEY_IN;      // KEY: Input
    
    // ߵƽ
    CS_HIGH;
    CLK_HIGH;
    DATA_HIGH;
    
    // ȴϵͳȶ
    Delay_ms(5);
    
    // (ZLG7289λ)
    DisplayClearAll();     
}

/*******************************************************************************
Function Name: SPIWriteAByte
*******************************************************************************/
void SPIWriteAByte(unsigned char byte)
{
    unsigned char i = 0;
 
    ZLG7289_DATA_OUT;    // DataΪ
    
    for(i = 0; i < 8; i++)
    {
        if((byte & 0x80) == 0x80)
            DATA_HIGH;
        else
            DATA_LOW;
        
        CLK_HIGH;
        Delay_us(8);
        CLK_LOW;
        Delay_us(8);  
        
        byte <<= 1;
    } 
}

/*******************************************************************************
Function Name: Write7289Cmd
Author       : Ʒ
Date         : 2010-08-02
Description  : ZLG7289ָʱ
Inputs       : unsigned char cmd -- ָ
Outputs      : None
NOTES        : 
*******************************************************************************/
void Write7289Cmd(unsigned char cmd)
{
    CS_LOW;
    Delay_us(50);
    
    SPIWriteAByte(cmd);
    
    CS_HIGH;
    Delay_us(50);
}

/*******************************************************************************
Function Name: Write7289CmdAndData

Description  : ZLG7289ָʱ
Inputs       : unsigned char cmd  -- ָ
               unsigned char data -- 
Outputs      : None
NOTES        : 
*******************************************************************************/
void Write7289CmdAndData(unsigned char cmd, unsigned char data)
{
    CS_LOW;
    Delay_us(50);
    
    SPIWriteAByte(cmd);                        // дָ
    
    Delay_us(25);
    
    SPIWriteAByte(data);                       // д
    
    CS_HIGH;
    Delay_us(50);
}


/*******************************************************************************
Function Name: DisplayClearAll
Description  : ZLG7289ʼ
*******************************************************************************/
void DisplayClearAll(void)
{
    Write7289Cmd(CMD_RESET);
}

/*******************************************************************************
Function Name: SegDisplay
Description  : ʾܵһ
Inputs       : unsigned char segbit -- Ҫʾڵڼλ
               unsigned char segnum -- ҪʾĶ
NOTES        : ݵ
*******************************************************************************/
void SegDisplay_0(unsigned char segbit, unsigned char segnum)
{
    Write7289CmdAndData(DECODE0 + segbit-1, segnum);
}

void SegDisplay_1(unsigned char segbit, unsigned char segnum)
{
    Write7289CmdAndData(DECODE1 + segbit-1, segnum);
}

void SegDisplay_2(unsigned char segbit, unsigned char segnum)
{
    Write7289CmdAndData(UNDECODE + segbit-1, segnum);
}

/*******************************************************************************
Function Name: BitDisplayNothing
Description  : ܵĳλʾӰλ
Inputs       : unsigned char dig_start -- Start Bit
               unsigned char dig_end   -- End Bit 
NOTES        : Decode Mode: Mode 0  
               Mode 0 Display Chars: 0123456789_EHLP(ʾ) 
*******************************************************************************/
void BitDisplayNothing(unsigned char dig_start, unsigned char dig_end)
{
    unsigned char i = 0;
    
    for(i = dig_start; i <= dig_end; i++)
    {
        Write7289CmdAndData(DECODE0 + i-1, DP_DONT_DISPLAY + NOTHING_DISPLAY);
    } 
}


/*******************************************************************************
Function Name: SPIReadAByte
Description  : ģSPIһֽ
Outputs      : unsigned char -- һֽ
*******************************************************************************/
unsigned char SPIReadAByte(void)
{
    unsigned char i = 0;
    unsigned char Byte = 0;
    
    ZLG7289_DATA_IN;    // DataΪ
    
    for(i = 0; i < 8; i++)
    {
        CLK_HIGH;
        Delay_us(8);
        Byte <<= 1;
        
        if(ZLG7289_DATA_PORT)
            Byte |= 0x01;
        
        CLK_LOW;
        Delay_us(8);
    }
    
    ZLG7289_DATA_OUT;    // DataΪ
    
    return(Byte);
}


/*******************************************************************************
Function Name: GetKey7289
Description  : ֵָ̼ʱ
Outputs      : unsigned char -- صǰֵ
*******************************************************************************/
unsigned char GetKey7289(void)
{
    unsigned char KeyNum = 0;

    while(ZLG7289_KEY_PORT);// ȴм
        
    CS_LOW;
    Delay_us(25);
    
    SPIWriteAByte(CMD_READ);
    Delay_us(25);
    KeyNum = SPIReadAByte();
    Delay_us(5);

    CS_HIGH;
    Delay_us(8);
    
    while(!ZLG7289_KEY_PORT);// ȴɿ
    
    return(KeyNum);
}

/*******************************************************************************
Function Name: DisplayData
Description  : ʾ
Inputs       : unsigned char dig_start -- Start Bit
               unsigned char dig_end   -- End Bit
               long int num      -- Data
Outputs      : RETURN O OR 1,IF RETURN 0,THE PROGRAM IS WELL EXECUDE
NOTES        : DP_DISPLAY: ӵʾ   DP_DONT_DISPLAY: ӵʾ  
               MINUS_DISPLAY: ʾ(мһ) 
               Decode Mode: Mode 0  
               Mode 0 Display Chars: 0123456789_EHLP(ʾ) 
               ʾиҲռһʾλʸʾһλ
               ҪʾСʱСڵλӵʾ
*******************************************************************************/
char DisplayData(unsigned char dig_start, unsigned char dig_end, float num)
{
    unsigned char i = 0;    
    int Integer=0;       //λ
    int Decimal=0;       //Сλ
    long int Num=num;    //ʱ
    float TempNum =0;    //תnum
    char Neg_f=0;        //־
    
    if(num < 0)
    {
      TempNum = -num;
      Neg_f = 1;
    }
    
    Num = (long int)TempNum;//תΪʹ
    
    if( Num >= 10 )         //ֵλ
    {
      while(Num >= 10)
      {
        Num /= 10;
        Integer++;
      }
      Integer += 1;
    }
    else 
      Integer = 1;          //һλ

    if(Integer == (dig_end-dig_start-Neg_f+1))//Ѿռʾλ
    {
      Num = (long int)(num+0.5);
      Decimal = 0;
    }
    else if(Integer < (dig_end-dig_start-Neg_f+1))//пʾλ
    {
      Decimal = dig_end - dig_start - Neg_f - Integer + 1;
      i = Decimal;
      TempNum = num;
      while(i--)
        TempNum *= 10;
      Num = (long int)(TempNum+0.5);//ʾ֣
    }
    
    if( ( Num > 99999999 ) || ( Num < -9999999 ) )//Խ
      Integer += 1;
      
    
    if( Integer > ( dig_end - dig_start - Neg_f + 1) )//̫󣬴
    {
      for(i=1;i<9;i++)
        SegDisplay_0(i,0x0a);
      return 1;
    }      
   if(Neg_f)      //֤
      Num = - Num;
    for( i = dig_end ; i >= dig_start ; i-- )//ӵλλ
    {
      Integer = Num % 10;
      Num -= Integer;
      Num /= 10;
      
      if(Neg_f && (i==dig_start))  //λ 
        Integer = 0x0a;
      if(i == (dig_end-Decimal))   //Сλ
        Integer += 0x80;
      SegDisplay_0(i,Integer);
    }
    return 0;
}




  